/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package metier;

import java.util.ArrayList;
import metier.Joueur;
import metier.Position;
import metier.Recif;
import metier.Tresor;

/**
 *
 * @author emile.lalorcey
 */
public class Jeu {
    private static final int TAILLE_CELLULE = 20;
    private static final int X_MAX = 400 - TAILLE_CELLULE;
    private static final int X_MIN = 0;
    private static final int Y_MAX = 400 - TAILLE_CELLULE;
    private static final int Y_MIN = 0;
    private final int NB_LIGNES = (X_MAX+TAILLE_CELLULE)/TAILLE_CELLULE;
    private final int NB_COL = (Y_MAX+TAILLE_CELLULE)/TAILLE_CELLULE;
    private final int NB_RECIF = 10;
    private Joueur leJoueur;
    private Tresor leTresor;
    private ArrayList<Recif> lesRecif;
    
    // Constructeur 
    public Jeu() {
        this.initJeu();
    }
    
    // Guetteur
    public Joueur getLeJoueur() {
        return leJoueur;
    }

    public Tresor getLeTresor() {
        return leTresor;
    }

    public ArrayList<Recif> getLesRecif() {
        return lesRecif;
    }

    public int getTAILLE_CELLULE() {
        return TAILLE_CELLULE;
    }

    public static int getX_MAX() {
        return X_MAX;
    }

    public static int getX_MIN() {
        return X_MIN;
    }

    public static int getY_MAX() {
        return Y_MAX;
    }

    public static int getY_MIN() {
        return Y_MIN;
    }

    public int getNB_LIGNES() {
        return NB_LIGNES;
    }

    public int getNB_COL() {
        return NB_COL;
    }

    public int getNB_RECIF() {
        return NB_RECIF;
    }
    
    

    // Setteur
    public void setLesRecif(ArrayList<Recif> lesRecif) {
        this.lesRecif = lesRecif;
    }
    
    public void setLeJoueur(Joueur leJoueur){    
        
        this.leJoueur = leJoueur;
    }

    public void setLeTresor(Tresor leTresor) {
        this.leTresor = leTresor;
    }

    //   Methodes
    private void initJeu() {
        //Initialisation du Trsor
        int y = this.genererNbAlea(0, NB_LIGNES);
        int x = this.genererNbAlea(0, NB_COL);
        Tresor chest = new Tresor("Coffre",y ,x);
        this.leTresor = chest;
        
        //Initialisation des Rcifs
        ArrayList<Recif> recifs = new ArrayList<Recif>();
        for(int i =0; i<NB_RECIF; i++){
            int dangereux = this.genererNbAlea(1, 3);
            boolean nouveau = true;
            Position pos1 = new Position();
            do{
                y = this.genererNbAlea(0, NB_LIGNES);
                x = this.genererNbAlea(0, NB_COL);
                pos1.setX(x);
                pos1.setY(y);
                for(Recif recif: recifs){
                    if(recif.getLaPosition().equals(pos1)){
                        nouveau = false;
                    }
                }
            }while(!nouveau);
            Recif plan = new Recif(dangereux, pos1);
            recifs.add(plan);
        }  
    }
    
    public int genererNbAlea(int min, int max){
        int nbAlea = min + (int)(Math.random() * max);
        return nbAlea;
    }
    
    public boolean gagner(Tresor tresor, Joueur joueur){
        boolean gagner = false;
        if(tresor.getLaPosition().getPosX() == joueur.getLaPosition().getPosX() && 
                tresor.getLaPosition().getPosY() == joueur.getLaPosition().getPosY()){
            gagner = true;
        }
        return gagner;
    }
    
}
